package solutions.bitbadger.documents.core.tests.java.integration;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.core.tests.integration.PgDB;

/**
 * PostgreSQL integration tests for the `Custom` object / `custom*` connection extension functions
 */
@DisplayName("Core | Java | PostgreSQL: Custom")
final public class PostgreSQLCustomIT {

    @Test
    @DisplayName("list succeeds with empty list")
    public void listEmpty() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.listEmpty(db);
        }
    }

    @Test
    @DisplayName("list succeeds with a non-empty list")
    public void listAll() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.listAll(db);
        }
    }

    @Test
    @DisplayName("jsonArray succeeds with empty array")
    public void jsonArrayEmpty() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.jsonArrayEmpty(db);
        }
    }

    @Test
    @DisplayName("jsonArray succeeds with a single-item array")
    public void jsonArraySingle() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.jsonArraySingle(db);
        }
    }

    @Test
    @DisplayName("jsonArray succeeds with a multi-item array")
    public void jsonArrayMany() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.jsonArrayMany(db);
        }
    }

    @Test
    @DisplayName("writeJsonArray succeeds with empty array")
    public void writeJsonArrayEmpty() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.writeJsonArrayEmpty(db);
        }
    }

    @Test
    @DisplayName("writeJsonArray succeeds with a single-item array")
    public void writeJsonArraySingle() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.writeJsonArraySingle(db);
        }
    }

    @Test
    @DisplayName("writeJsonArray succeeds with a multi-item array")
    public void writeJsonArrayMany() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.writeJsonArrayMany(db);
        }
    }

    @Test
    @DisplayName("single succeeds when document not found")
    public void singleNone() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.singleNone(db);
        }
    }

    @Test
    @DisplayName("single succeeds when a document is found")
    public void singleOne() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.singleOne(db);
        }
    }

    @Test
    @DisplayName("jsonSingle succeeds when document not found")
    public void jsonSingleNone() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.jsonSingleNone(db);
        }
    }

    @Test
    @DisplayName("jsonSingle succeeds when a document is found")
    public void jsonSingleOne() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.jsonSingleOne(db);
        }
    }

    @Test
    @DisplayName("nonQuery makes changes")
    public void nonQueryChanges() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.nonQueryChanges(db);
        }
    }

    @Test
    @DisplayName("nonQuery makes no changes when where clause matches nothing")
    public void nonQueryNoChanges() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.nonQueryNoChanges(db);
        }
    }

    @Test
    @DisplayName("scalar succeeds")
    public void scalar() throws DocumentException {
        try (PgDB db = new PgDB()) {
            CustomFunctions.scalar(db);
        }
    }
}
