package solutions.bitbadger.documents.groovy.tests.integration

import com.fasterxml.jackson.databind.ObjectMapper
import solutions.bitbadger.documents.DocumentSerializer

/**
 * A JSON serializer using Jackson's default options
 */
class JacksonDocumentSerializer implements DocumentSerializer {

    private def mapper = new ObjectMapper()

    @Override
    def <TDoc> String serialize(TDoc document) {
        return mapper.writeValueAsString(document)
    }

    @Override
    def <TDoc> TDoc deserialize(String json, Class<TDoc> clazz) {
        return mapper.readValue(json, clazz)
    }
}
