package solutions.bitbadger.documents.groovy.tests.integration

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test

/**
 * PostgreSQL integration tests for the `Count` object / `count*` connection extension functions
 */
@DisplayName('Groovy | PostgreSQL: Count')
final class PostgreSQLCountIT {

    @Test
    @DisplayName('all counts all documents')
    void all() {
        new PgDB().withCloseable CountFunctions.&all
    }

    @Test
    @DisplayName('byFields counts documents by a numeric value')
    void byFieldsNumeric() {
        new PgDB().withCloseable CountFunctions.&byFieldsNumeric
    }

    @Test
    @DisplayName('byFields counts documents by a alphanumeric value')
    void byFieldsAlpha() {
        new PgDB().withCloseable CountFunctions.&byFieldsAlpha
    }

    @Test
    @DisplayName('byContains counts documents when matches are found')
    void byContainsMatch() {
        new PgDB().withCloseable CountFunctions.&byContainsMatch
    }

    @Test
    @DisplayName('byContains counts documents when no matches are found')
    void byContainsNoMatch() {
        new PgDB().withCloseable CountFunctions.&byContainsNoMatch
    }

    @Test
    @DisplayName('byJsonPath counts documents when matches are found')
    void byJsonPathMatch() {
        new PgDB().withCloseable CountFunctions.&byJsonPathMatch
    }

    @Test
    @DisplayName('byJsonPath counts documents when no matches are found')
    void byJsonPathNoMatch() {
        new PgDB().withCloseable CountFunctions.&byJsonPathNoMatch
    }
}
