package solutions.bitbadger.documents.groovy.tests.integration

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test

/**
 * PostgreSQL integration tests for the `Delete` object / `deleteBy*` connection extension functions
 */
@DisplayName('Groovy | PostgreSQL: Delete')
final class PostgreSQLDeleteIT {

    @Test
    @DisplayName('byId deletes a matching ID')
    void byIdMatch() {
        new PgDB().withCloseable DeleteFunctions.&byIdMatch
    }

    @Test
    @DisplayName('byId succeeds when no ID matches')
    void byIdNoMatch() {
        new PgDB().withCloseable DeleteFunctions.&byIdNoMatch
    }

    @Test
    @DisplayName('byFields deletes matching documents')
    void byFieldsMatch() {
        new PgDB().withCloseable DeleteFunctions.&byFieldsMatch
    }

    @Test
    @DisplayName('byFields succeeds when no documents match')
    void byFieldsNoMatch() {
        new PgDB().withCloseable DeleteFunctions.&byFieldsNoMatch
    }

    @Test
    @DisplayName('byContains deletes matching documents')
    void byContainsMatch() {
        new PgDB().withCloseable DeleteFunctions.&byContainsMatch
    }

    @Test
    @DisplayName('byContains succeeds when no documents match')
    void byContainsNoMatch() {
        new PgDB().withCloseable DeleteFunctions.&byContainsNoMatch
    }

    @Test
    @DisplayName('byJsonPath deletes matching documents')
    void byJsonPathMatch() {
        new PgDB().withCloseable DeleteFunctions.&byJsonPathMatch
    }

    @Test
    @DisplayName('byJsonPath succeeds when no documents match')
    void byJsonPathNoMatch() {
        new PgDB().withCloseable DeleteFunctions.&byJsonPathNoMatch
    }
}
