package solutions.bitbadger.documents.groovy.tests.integration

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test

/**
 * PostgreSQL integration tests for the `Exists` object / `existsBy*` connection extension functions
 */
@DisplayName('Groovy | PostgreSQL: Exists')
final class PostgreSQLExistsIT {

    @Test
    @DisplayName('byId returns true when a document matches the ID')
    void byIdMatch() {
        new PgDB().withCloseable ExistsFunctions.&byIdMatch
    }
    
    @Test
    @DisplayName('byId returns false when no document matches the ID')
    void byIdNoMatch() {
        new PgDB().withCloseable ExistsFunctions.&byIdNoMatch
    }
    
    @Test
    @DisplayName('byFields returns true when documents match')
    void byFieldsMatch() {
        new PgDB().withCloseable ExistsFunctions.&byFieldsMatch
    }
    
    @Test
    @DisplayName('byFields returns false when no documents match')
    void byFieldsNoMatch() {
        new PgDB().withCloseable ExistsFunctions.&byFieldsNoMatch
    }
    
    @Test
    @DisplayName('byContains returns true when documents match')
    void byContainsMatch() {
        new PgDB().withCloseable ExistsFunctions.&byContainsMatch
    }
    
    @Test
    @DisplayName('byContains returns false when no documents match')
    void byContainsNoMatch() {
        new PgDB().withCloseable ExistsFunctions.&byContainsNoMatch
    }
    
    @Test
    @DisplayName('byJsonPath returns true when documents match')
    void byJsonPathMatch() {
        new PgDB().withCloseable ExistsFunctions.&byJsonPathMatch
    }
    
    @Test
    @DisplayName('byJsonPath returns false when no documents match')
    void byJsonPathNoMatch() {
        new PgDB().withCloseable ExistsFunctions.&byJsonPathNoMatch
    }
}
