package solutions.bitbadger.documents.groovy.tests.integration

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test

/**
 * PostgreSQL integration tests for the `Patch` object / `patchBy*` connection extension functions
 */
@DisplayName('Groovy | PostgreSQL: Patch')
final class PostgreSQLPatchIT {

    @Test
    @DisplayName('byId patches an existing document')
    void byIdMatch() {
        new PgDB().withCloseable PatchFunctions.&byIdMatch
    }

    @Test
    @DisplayName('byId succeeds for a non-existent document')
    void byIdNoMatch() {
        new PgDB().withCloseable PatchFunctions.&byIdNoMatch
    }

    @Test
    @DisplayName('byFields patches matching document')
    void byFieldsMatch() {
        new PgDB().withCloseable PatchFunctions.&byFieldsMatch
    }

    @Test
    @DisplayName('byFields succeeds when no documents match')
    void byFieldsNoMatch() {
        new PgDB().withCloseable PatchFunctions.&byFieldsNoMatch
    }

    @Test
    @DisplayName('byContains patches matching document')
    void byContainsMatch() {
        new PgDB().withCloseable PatchFunctions.&byContainsMatch
    }

    @Test
    @DisplayName('byContains succeeds when no documents match')
    void byContainsNoMatch() {
        new PgDB().withCloseable PatchFunctions.&byContainsNoMatch
    }

    @Test
    @DisplayName('byJsonPath patches matching document')
    void byJsonPathMatch() {
        new PgDB().withCloseable PatchFunctions.&byJsonPathMatch
    }

    @Test
    @DisplayName('byJsonPath succeeds when no documents match')
    void byJsonPathNoMatch() {
        new PgDB().withCloseable PatchFunctions.&byJsonPathNoMatch
    }
}
