package solutions.bitbadger.documents.kotlinx.tests.integration

import org.junit.jupiter.api.DisplayName
import kotlin.test.Test

/**
 * SQLite integration tests for the `Document` object / `insert`, `save`, `update` connection extension functions
 */
@DisplayName("KotlinX | SQLite: Document")
class SQLiteDocumentIT {

    @Test
    @DisplayName("insert works with default values")
    fun insertDefault() =
        SQLiteDB().use(DocumentFunctions::insertDefault)

    @Test
    @DisplayName("insert fails with duplicate key")
    fun insertDupe() =
        SQLiteDB().use(DocumentFunctions::insertDupe)

    @Test
    @DisplayName("insert succeeds with numeric auto IDs")
    fun insertNumAutoId() =
        SQLiteDB().use(DocumentFunctions::insertNumAutoId)

    @Test
    @DisplayName("insert succeeds with UUID auto ID")
    fun insertUUIDAutoId() =
        SQLiteDB().use(DocumentFunctions::insertUUIDAutoId)

    @Test
    @DisplayName("insert succeeds with random string auto ID")
    fun insertStringAutoId() =
        SQLiteDB().use(DocumentFunctions::insertStringAutoId)

    @Test
    @DisplayName("save updates an existing document")
    fun saveMatch() =
        SQLiteDB().use(DocumentFunctions::saveMatch)

    @Test
    @DisplayName("save inserts a new document")
    fun saveNoMatch() =
        SQLiteDB().use(DocumentFunctions::saveNoMatch)

    @Test
    @DisplayName("update replaces an existing document")
    fun updateMatch() =
        SQLiteDB().use(DocumentFunctions::updateMatch)

    @Test
    @DisplayName("update succeeds when no document exists")
    fun updateNoMatch() =
        SQLiteDB().use(DocumentFunctions::updateNoMatch)
}
