package solutions.bitbadger.documents.kotlinx.tests.integration

import solutions.bitbadger.documents.AutoId
import java.sql.Connection

/**
 * Common interface for PostgreSQL and SQLite throwaway databases
 */
abstract class ThrowawayDatabase : AutoCloseable {

    /** The name of the throwaway database */
    protected val dbName = "throwaway_${AutoId.generateRandomString(8)}"

    /** The database connection for the throwaway database */
    abstract val conn: Connection

    /**
     * Determine if a database object exists
     *
     * @param name The name of the object whose existence should be checked
     * @return True if the object exists, false if not
     */
    abstract fun dbObjectExists(name: String): Boolean
}
