package solutions.bitbadger.documents.scala.tests.integration

import solutions.bitbadger.documents.DocumentSerializer
import com.fasterxml.jackson.databind.ObjectMapper

/**
 * A JSON serializer using Jackson's default options
 */
class JacksonDocumentSerializer extends DocumentSerializer:

  private val mapper = ObjectMapper()

  override def serialize[TDoc](document: TDoc): String =
    mapper.writeValueAsString(document)

  override def deserialize[TDoc](json: String, clazz: Class[TDoc]): TDoc =
    mapper.readValue(json, clazz)
