package solutions.bitbadger.documents.scala.tests.integration

import solutions.bitbadger.documents.{Configuration, Parameter, ParameterType}
import solutions.bitbadger.documents.scala.Results
import solutions.bitbadger.documents.scala.extensions.*
import solutions.bitbadger.documents.scala.tests.TEST_TABLE

import java.io.File
import java.sql.Connection

/**
 * A wrapper for a throwaway SQLite database
 */
class SQLiteDB extends ThrowawayDatabase:

  Configuration.setConnectionString(s"jdbc:sqlite:$dbName.db")

  override val conn: Connection = Configuration.dbConn()

  conn.ensureTable(TEST_TABLE)

  override def close(): Unit =
    conn.close()
    File(s"$dbName.db").delete()
    Configuration.setConnectionString(null)

  override def dbObjectExists(name: String): Boolean =
    conn.customScalar[Boolean]("SELECT EXISTS (SELECT 1 FROM sqlite_master WHERE name = :name) AS it",
      Parameter(":name", ParameterType.STRING, name) :: Nil, Results.toExists)

